//////////////////////////////////////////////////////////
//// Implementierung der Methoden class Sema
//////////////////////////////////////////////////////////

#include "Sema.h"
#include <iostream.h>

Sema::Sema(int i = 0)
{

  if (pthread_mutex_init(&mux, NULL) < 0) 
  {
    cout << "Sema init: Cannot initialize sem.mux" << "\n";
  }
  if (pthread_cond_init(&pos, NULL) < 0) 
  {
    cout << "Sema init: Cannot initialize sem.pos" << "\n";
  }
  if (i >= 0) {
    s = i;
  } else {
    s = 0;
  }
  init = s;
  del = 0;
}

Sema::~Sema()
{
  if (s != init) { 
    cout << "Sema destruction: pending operations: " 
         << (s-init) << "\n";
  }
}

void
Sema::P()
{
  if (pthread_mutex_lock(&mux) < 0) {
    cout << "P: Cannot lock sem.mux" << "\n";
  }
  while (s <= 0) {
    del++;
    if (pthread_cond_wait(&pos, &mux) < 0) {
      cout << "P: Cannot wait on sem.pos" << "\n";
    }
    del--;
  }
  s--;
  if (pthread_mutex_unlock(&mux) < 0) {
    cout << "seminit: Cannot unlock sem.mux" << "\n";
  }
}

void
Sema::V()
{
  if (pthread_mutex_lock(&mux) < 0) {
   cout << "P: Cannot lock sem.mux" << "\n";
  }
  s++;
  if (del > 0) {
    if (pthread_cond_signal(&pos) < 0) {
      cout << "P: Cannot signal sem.pos" << "\n";
    }
  }
  if (pthread_mutex_unlock(&mux) < 0) {
     cout << "seminit: Cannot unlock sem.mux" << "\n";
  }
}
